%% Copyright 2012 Soren Hauberg
%%
%% This program is free software: you can redistribute it and/or modify
%% it under the terms of the GNU General Public License as published by
%% the Free Software Foundation, either version 3 of the License, or
%% (at your option) any later version.
%%
%% This program is distributed in the hope that it will be useful,
%% but WITHOUT ANY WARRANTY; without even the implied warranty of
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%% GNU General Public License for more details.
%%
%% You should have received a copy of the GNU General Public License
%% along with this program.  If not, see <http://www.gnu.org/licenses/>.

function c_short = shorten_curve (cum_lengths, curve, dest_len)
  [N, D] = size (curve);
  eval_idx = [cum_lengths(cum_lengths < dest_len), dest_len];
  n = numel (eval_idx);
  c_short = NaN (n, D);
  for d = 1:D
    c_short (:, d) = interp1 (cum_lengths, curve (:, d), eval_idx, 'spline');
  end % for
end % function
