%% Copyright 2012 Soren Hauberg
%%
%% This program is free software: you can redistribute it and/or modify
%% it under the terms of the GNU General Public License as published by
%% the Free Software Foundation, either version 3 of the License, or
%% (at your option) any later version.
%%
%% This program is distributed in the hope that it will be useful,
%% but WITHOUT ANY WARRANTY; without even the implied warranty of
%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%% GNU General Public License for more details.
%%
%% You should have received a copy of the GNU General Public License
%% along with this program.  If not, see <http://www.gnu.org/licenses/>.

function im_out = trace_metric_image (manifold, lim)
  [x, y] = meshgrid (lim);
  xy = [x(:), y(:)].';
  Ms = metric_tensor (xy, manifold);
  if (~strcmp (manifold.weight_scheme, {'diagonal', 'parzen', 'local diagonal pca'}))
    im = reshape (Ms (1, 1, :) + Ms (2, 2, :), size (x));
  else
    im = reshape (sum (Ms, 1), size (x));
  end % if
  if (nargout == 0)
    imagesc (lim, lim, im);
    set (gca (), 'clim', [-1, max(im(:))]);
    colormap gray
  else
    im_out = im;
  end % if
end % function
